# Objecttypen API

## Dependencies

In order to use the Objecttypen API, the Objecttypen API module needs to be added as a dependency. The following can be added to your project, depending on whether Maven or Gradle is used:

### Backend

The samples below assume the [valtimo-dependency-versions](/fundamentals/getting-started/modules/core/valtimo-dependency-versions.md) module is used. If not, please specify the artifact version as well.

#### Maven dependency:

```xml
<dependencies>
    <dependency>
        <groupId>com.ritense.valtimo</groupId>
        <artifactId>objecttypen-api</artifactId>
    </dependency>
</dependencies>
```

#### Gradle dependency:

```kotlin
dependencies {
  implementation("com.ritense.valtimo:objecttypen-api")
}
```

### Frontend

A general instruction to add a front-end plugin to the implementation can be found in the [plugin documentation](/fundamentals/getting-started/modules/core/plugin.md#adding-a-front-end-plugin-to-the-implementation).

In order to use the Object Typen API plugin in the frontend the following can be added to your `app.module.ts`:

```typescript
import { ObjecttypenApiPluginModule, objecttypenApiPluginSpecification } from '@valtimo/plugin';

@NgModule({
  imports: [
      ObjecttypenApiPluginModule,
  ],
  providers: [
      {
          provide: PLUGIN_TOKEN,
          useValue: [
              objecttypenApiPluginSpecification,
          ]
      }
  ]
})
```

Before the Object Typen API plugin can be used, an authentication plugin is needed. One such authentication plugin is the Objecten API authentication plugin. Instructions on how to add this plugin can be found in the [Objecten API authentication documentation](/fundamentals/getting-started/modules/zgw/objecten-api-authentication.md).


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.valtimo.nl/fundamentals/getting-started/modules/zgw/objecttypen-api.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
